﻿#https://msdn.microsoft.com/en-us/library/windows/desktop/ee671195(v=vs.85).aspx
#coding:utf-8
from globalCommands import GlobalCommands

from oleacc import STATE_SYSTEM_SELECTABLE, STATE_SYSTEM_SELECTED, STATE_SYSTEM_FOCUSABLE, STATE_SYSTEM_VALID
from wx import Menu, EVT_MENU,CallAfter,ITEM_CHECK, MenuItem
from NVDAObjects.IAccessible import IAccessible, getNVDAObjectFromPoint
from UIAHandler import handler, UIA_ControlTypePropertyId ,UIA_TabItemControlTypeId ,UIA_TabControlTypeId, TreeScope_Descendants ,TreeScope_Children, IUIAutomationLegacyIAccessiblePattern, UIA_LegacyIAccessibleStatePropertyId, UIA_TreeControlTypeId ,UIA_TableControlTypeId,UIA_ListControlTypeId 
import addonHandler,  os, sys
_curAddon=addonHandler.getCodeAddon()
sharedPath=os.path.join(_curAddon.path,"AppModules", "shared")
sys.path.append(sharedPath)
from utilTB import showNVDAMenu , getIA2Attribute
import utilTB2
import py3compatibility
from  py3compatibility import _unicode, u
del sys.path[-1]
from ui import message
import speech, api, controlTypes
from controlTypes import  ROLE_TAB
from time import sleep

#désactivé
			
class PageTab (IAccessible):
	def initOverlayClass (self):
		if self.role == ROLE_TAB  :
			c =self.container 
			if  hasattr(c,"IA2Attributes") and "id" in c.IA2Attributes and  c.IA2Attributes["id"] !="view-tabs" : 
				self.keyboardShortcut= "control+%s" % getIA2Attribute (self,attribute_name="posinset")
				
	def getObjPageTab (self, ct): return ct.ElementFromHandle(api.getForegroundObject ().windowHandle).FindFirst (TreeScope_Descendants,ct.CreatePropertyCondition (UIA_ControlTypePropertyId,UIA_TabControlTypeId ))

	def script_activePageTab (self,gesture):
		ct =handler.clientObject
		pageTab =self.getObjPageTab (ct)
		if not pageTab : return  gesture.send ()
		pageTabItem =pageTab.FindAll(TreeScope_Children,ct.CreatePropertyCondition (UIA_ControlTypePropertyId ,UIA_TabItemControlTypeId ))
		count,mainKeyName = pageTabItem.Length,(9 if gesture.mainKeyName =="0" else (int (gesture.mainKeyName)-1))
		#changements pour dernier onglet
		if mainKeyName >=count -1: 
			st=str(count)
			message ("Onglet "+st+" sur "+st)
			mainKeyName=count-1
		pageTabItem =pageTabItem.GetElement (mainKeyName)
		newName =pageTabItem.CurrentName
		if self.role != ROLE_TAB and self.appModule.currentFrame =="messengerWindow":message (u"onglet %s" % newName)
		pageTabItem.GetCurrentPattern (10018).QueryInterface(IUIAutomationLegacyIAccessiblePattern).DoDefaultAction ()
		from time import sleep
		sleep(0.4)
		name=newName
		if name in (u"Fichiers enregistrés", "Options", "Gestionnaire de modules complémentaires"):
			oldSpeechMode = utilTB2.getSpeechMode()
			try :
				utilTB2.setSpeechMode_off()
				(x,y,l,h)=api.getForegroundObject().location
				x,y,l,h=int(x),int(y),int(l),int(h)
				o=getNVDAObjectFromPoint(x+l-50,y+h-80)
				if not (o.role==14 and  o.name ==u"Fichiers enregistrés"):
					while o and not o.role in (56,54): o=o.parent
					o=o.firstChild
					while o and o.role !=14 : o=o.next
				o.setFocus()	
				sleep(0.2)
				api.processPendingEvents()
				sleep(0.2)
				utilTB2.setSpeechMode(oldSpeechMode)	
				sleep(0.2)
				message (controlTypes.roleLabels[o.role])
				if name ==u"Fichiers enregistrés" and not o.childCount: message (u"Il n'y a aucun fichier enregistré")
				return message(api.getFocusObject().name)
				# return	
			except :
				utilTB2.setSpeechMode(oldSpeechMode)
				return
	script_activePageTab.__doc__ = u"Changement d'onglet par Ctrl+chiffre"
	
	def script_showPageTabItemOnMenu (self,gesture):
		message("on menu")
		print("on menu")
		return
		ct =handler.clientObject
		pageTab =self.getObjPageTab (ct)
		if not pageTab :return gesture.send ()
		self.pageTabItem =pageTab.FindAll (TreeScope_Children, ct.CreatePropertyCondition (UIA_ControlTypePropertyId ,UIA_TabItemControlTypeId ))
		mainMenu =Menu ()
		for e in range (self.pageTabItem.Length):
			element =self.pageTabItem.GetElement (e)
			menuitem =MenuItem (mainMenu,e+1,element.CurrentName+"\tControl+%s" % (e+1 if e!=10 else 0),kind =ITEM_CHECK)
			state=bool (element.GetCurrentPropertyValue (UIA_LegacyIAccessibleStatePropertyId )&STATE_SYSTEM_SELECTED)
			menuitem.Check(state)
			menuitem.Enable (not state)
			mainMenu.AppendItem (menuitem)
		mainMenu.Bind (EVT_MENU, self.onMenu_pageTab)
		showNVDAMenu (mainMenu)
	script_showPageTabItemOnMenu.__doc__ = u"Affiche un menu contextuel , non utilisé"
	
	def onMenu_pageTab (self,evt):
		CallAfter (self.pageTabItem.GetElement (evt.Id-1).GetCurrentPattern (10018).QueryInterface(IUIAutomationLegacyIAccessiblePattern).DoDefaultAction )
	def getCurrentPageName (self):
		if self.role == ROLE_TAB and self.hasFocus:return self.name
		ct =handler.clientObject
		c= ct.CreateAndCondition (ct.CreatePropertyCondition (UIA_ControlTypePropertyId ,UIA_TabItemControlTypeId ),ct.CreatePropertyCondition (30096 ,STATE_SYSTEM_SELECTABLE| STATE_SYSTEM_SELECTED| STATE_SYSTEM_FOCUSABLE))
		try:
			item =self.getObjPageTab (ct).FindFirst (TreeScope_Children, c)
		except:return False
		return (False if not item else item.CurrentName)
	def script_title (self, gesture):
		GlobalCommands().script_title (gesture)
		if self.appModule.currentFrame == "messengerWindow": return 
		pageName =self.getCurrentPageName ()
		if pageName :message (u"dans l'onglet %s" % pageName)
	script_title.__doc__ = u"Lit le nom de l'onglet"
	__gestures ={
		"kb:nvda+t":"title",
		"kb:control+1":"showPageTabItemOnMenu",
		"kb:control+2":"activePageTab",
		"kb:control+3":"activePageTab",
		"kb:control+4":"activePageTab",
		"kb:control+5":"activePageTab",
		"kb:control+6":"activePageTab",
		"kb:control+7":"activePageTab",
		"kb:control+8":"activePageTab",
		"kb:control+9":"activePageTab",
		"kb:control+0":"activePageTab"} 
