﻿#coding:utf-8
# version 2.1.1c Braille (speak replaced with message)
from scriptHandler import getLastScriptRepeatCount
import speech 
from speech import speak
from speech import speakSpelling
from tones  import beep
from NVDAObjects.IAccessible import IAccessible
import controlTypes
from keyboardHandler import KeyboardInputGesture
from ui import message
from api import copyToClip, getForegroundObject 
from wx import CallAfter, CallLater
import addonHandler,  os, sys
_curAddon=addonHandler.getCodeAddon()
sharedPath=os.path.join(_curAddon.path,"AppModules", "shared")
sys.path.append(sharedPath)
import utilTB
from py3compatibility  import _unicode
del sys.path[-1]
#justActivated = False
lastWord=None
newWord=None

class spellCheckDlg (IAccessible):
	def initOverlayClass (self):
		role =self.role
		#  justActivated nécessaire pour que cela fonctionne
		justActivated = self.appModule.spellDlgActivated 
		id =(self.IA2Attributes["id"] if hasattr (self,"IA2Attributes") and "id" in self.IA2Attributes else None)
		if role == (controlTypes.Role.EDITABLETEXT if hasattr(controlTypes, "Role") else controlTypes.ROLE_EDITABLETEXT) :
			#beep (500, 50)
			self.name=u"Mot mal orthographié : %s , remplacé par " % self.parent.getChild(1).name # v3
			self.bindGestures ({"kb:nvda+tab":"reportFocus","kb:ALT+UPARROW":"reportFocus", "kb:enter":"enterFromEdit", "kb:shift+enter":"enterFromEdit", "kb:control+enter":"enterFromEdit", "kb:control+shift+enter":"enterFromEdit", "kb:alt+enter":"enterFromEdit", "kb:alt+i":"altLetter", "kb:alt+n":"altLetter", "kb:alt+r":"altLetter", "kb:alt+t":"altLetter", "kb:alt+a":"altLetter"})
			if  justActivated :
				self.appModule.spellDlgActivated  = False
				#beep (100, 30)
				CallAfter (self.sayWords1)
		""" elif role == (controlTypes.Role.LISTITEM if hasattr(controlTypes, "Role") else controlTypes.ROLE_LISTITEM) and not self.previous :self.keyboardShortcut =self.container.keyboardShortcut """
	def script_enterFromEdit (self,gesture):
		# self is the editable text field 
		if "control" in gesture.modifierNames : # Ignore orAll or Ignore 
			if "shift" in gesture.modifierNames : # Ignore orAll or Ignore 
				self.pressButton ("ignoreAll")
			else :
				self.pressButton ("ignore")
		elif "alt" in gesture.modifierNames :
			self.pressButton("addtodictionary")
		else : # no modifiers replacAll or replace			
			if "shift" in  gesture.modifierNames : 
				self.pressButton ("replaceAll")
			else :
				self.pressButton ("replace")
		# v3 & v2.1.1 announcement of the following mispelled word if not None
		self.sayWords1()
	script_enterFromEdit.__doc__ = u"gère différentes combinaisons autour de Enter pour simuler les boutons de correction"
	
	def sayWords1 (self) :
		global lastWord, newWord
		verTB = utilTB.versionTB ()
		newWord=self.parent.getChild (1).name
		misp = self.parent.getChild (1).name
		if u"Vérification" in misp : return message(u"Vérification de l'orthographe terminée")
		spell =self.appModule.options["msgcomposeWindow"].as_bool ("spellWords")
		replace= self.value
		if self.value :
			if lastWord!=newWord : message ("Mot mal orthographié : %s" % misp)
			if spell : speakSpelling (misp)
			if  lastWord!=newWord : message ("Remplacer par : %s" % replace)
			if spell : speakSpelling (replace)
		else :
			message ("Mot mal orthographié : %s, pas de suggestion." % misp) 
		lastWord = newWord
	def script_altLetter (self, gesture) :
		#beep (500, 50)
		mk = gesture.mainKeyName
		# mk letters : language dependant
		if mk == "i" : btn = "ignore"
		elif mk  == "n" : btn = "ignoreAll"
		elif mk == "a" : btn ="addtodictionary"
		elif mk == "t" : btn = "replaceAll"
		elif mk == "r" : btn = "replace"
		self.pressButton (btn)
		# v3 & v2.1.1 announcement of the following mispelled word if not None
		self.sayWords1 ()
	def pressButton (self, btnID) :
		verTB = utilTB.versionTB ()
		oDlg = self.parent # v3 TB 91
		#oDlg.parent.name = ""
		#message ("oDlg role :" + str(oDlg.role) + ", name : "+ str(oDlg.name))
		o = oDlg.firstChild
		btnID = btnID.lower()
		obj = None
		while o :
			if o.role == 9 : # button
				ID = (o.IA2Attributes["id"] if hasattr (o,"IA2Attributes") and "id" in o.IA2Attributes else False)
				if  ID :
					ID = ID.lower ()
					if ID == btnID :
						obj = o
						break
			o = o.next
		if not obj : return False
		#cmdVol = #speech.VolumeCommand
		#cmdVol(0.4)
		message (obj.name)
		#cmdVol(1)
		obj.doAction ()

	def script_reportFocus (self,gesture):
		c = getLastScriptRepeatCount () 
		misp = self.parent.getChild (1).name
		#print (misp)
		message(misp)
		if c == 1 :
			#speak ([u"Mot mal orthographié : " + misp])
			speak  ([(u"remplacé, {0} . par . {1}").format ((" . ").join (list (self.parent.getChild (1).name)), (" . ").join (list (self.value)))],symbolLevel  =0)
		elif c == 0 :
			a = u"Remplacer  : " + misp + " : "
			message  (a)
			speakSpelling (misp)
			a = u" par : " + self.value + " : "
			message  (a)
			speakSpelling (self.value)
		else :
			copyToClip (misp)
			message (misp + u", copié dans le presse-papiers")
	script_reportFocus.__doc__ = u"Lire ou épeler le mot mal orthographié et le mot proposé par NVDA+Tab"
	
