﻿#-*- coding:utf-8 -*
from NVDAObjects.IAccessible import IAccessible
from scriptHandler import getLastScriptRepeatCount
from speech import speakSpelling
from oleacc import STATE_SYSTEM_MARQUEED, STATE_SYSTEM_PRESSED, STATE_SYSTEM_UNAVAILABLE
from UIAHandler import handler, UIA_LegacyIAccessibleStatePropertyId, UIA_ControlTypePropertyId, UIA_ButtonControlTypeId, UIA_ToolBarControlTypeId, UIA_NamePropertyId
clientObject =handler.clientObject
from ui import message

class StatusBar (IAccessible):
	def script_readStatusBar (self, gesture):
		buttonPressed = self.getButtonPressed()
		text =buttonPressed
		if getLastScriptRepeatCount ():
			speakSpelling (text)
		else:
			message (text)
	script_readStatusBar.__doc__ = u"Lire la barre d'état"
	def getButtonPressed (self):
		l, o =[] , clientObject.ElementFromHandle (self.windowHandle).FindAll (4, clientObject.CreatePropertyCondition (UIA_LegacyIAccessibleStatePropertyId               ,STATE_SYSTEM_MARQUEED| STATE_SYSTEM_PRESSED))
		for e in range (o.Length): l.append (o.GetElement (e).CurrentName)
		return (", ").join (l)+u" Activé"  if l else ""
	def script_sendMessage (self,gesture):
		CPC=clientObject.CreatePropertyCondition
		try:
			o= clientObject.ElementFromHandle (self.windowHandle).FindFirst(4,clientObject.CreateAndCondition (CPC(UIA_ControlTypePropertyId, UIA_ButtonControlTypeId),CPC(UIA_NamePropertyId, "Envoyer"))) 
			if o and o.GetCurrentPropertyValue (UIA_LegacyIAccessibleStatePropertyId)&STATE_SYSTEM_UNAVAILABLE :
				return message (u"Bouton Envoyer inactif")
			else : gesture.send ()
		except : 
			message ("Bouton Envoyer non atteint")
			return False 
	script_sendMessage.__doc__ = u"Envoyer un message"
	
	__gestures = {"kb:nvda+end":"readStatusBar",
"kb:control+enter":"sendMessage",
"kb:control+shift+enter":"sendMessage"
}