# coding:utf-8
from re import compile
import speech
from speech import speak
import characterProcessing
if not hasattr(characterProcessing, "SYMLVL_SOME"):
	SYMLVL_SOME = characterProcessing.SymbolLevel.SOME
else:
	from characterProcessing import SYMLVL_SOME
from ui import message
from api import copyToClip, getForegroundObject
from wx import CallAfter, CallLater
import utilTB
import zeDevTools as z
import controlTypes
import winUser

curFrame = "init"
curTab = "init"
lastMenuItem = ""
refreshFrame = True
testMode = False
useKeyNav = True
directKeyNav = True
folderSearching = False
# new speechMode functions by Paulber19 for NVDA 2021.1+ ander previous 
def getSpeechMode():
	try:
		# for nvda version >= 2021.1
		return speech.getState().speechMode
	except AttributeError:
		return speech.speechMode

def setSpeechMode(mode):
	try:
		# for nvda version >= 2021.1
		speech.setSpeechMode(mode)
	except AttributeError:
		speech.speechMode = mode


def setSpeechMode_off():
	#print(u"Fonction setSpeechMode_off")
	try:
		# for nvda version >= 2021.1
		speech.setSpeechMode(speech.SpeechMode.off)
	except AttributeError:
		speech.speechMode = speech.speechMode_off
def getTreeViewFromItem(oItem) :
	"""Returns the treview  object (role=20) which is the ancestor of a treeItem (role =21)"""
	if oItem.role != 21 : # treitem
		return None
	o = oItem.parent
	while o :
		if o.role == 20 : # role_treeview
			return o
		o = o.parent
	return None

#Suppport function for document.py and contentMail.py in messengerwindow 
def filterSpeakDoc (endSubj, text, reverse, filter) :
	#copyToClip (u"endSubj [" + endSubj + "] text=" + text)
	#message ("Fonction filterSpeakDoc, texte source copié dans le presse-papiers")
	if not filter :
		message ("Lecture non filtrée.")
	text=text.replace ("\n"," ")
	#suppression du tableau de yahoo 
	regExp = compile ("\<table\>.+?groups\.yahoo\.com.+?\</table\>")
	text=regExp.sub (" ",text)
	#remplacement de la balise lien (<a...</>
	regExp =compile ("(\<a .+?\>(.+?)\</a\>)")
	l=regExp.findall (text)
	for e in l :
		text_link = e[1]
		if "mailto" in e[0]: continue
		elif text_link.startswith ("http"):text =text.replace (e[0],_(u" lien cliquable "))
		#elif e[0].find ("yahoo.com")!=-1:text=text.replace (e[0]," ")
		else: text =text.replace (e[0],_(u" lien %s ") % text_link)
	#remplacement des objets youtube par du texte  (dans le flus rss)
	reg =compile ("\<iframe.+?\</iframe\>")
	text =reg.sub (_(u"objet youtube présent. "),text)
	#suppression du titre dans les flus rss
	reg =compile ("\<title\>.+?\</title\>")
	text=reg.sub (" ",text)
	#suppression de la fin de google groupe 
	s=_(u"Vous recevez ce message, car vous êtes abonné au groupe Google")
	i =text.find (s)
	if i !=-1 :text=text[:i]
	#suppression de fin de message yahoo
	reg =compile ("\-{36}")
	if reg.search (text):text =text[:text.find ("-"*36)]
	s="    <!--~-|**|PrettyHtmlStart|**|-~-->"
	i=text.find (s)
	if i!=-1:text=text[:i]
	text=text.replace ("\n"," ").replace ("&nbsp;","").replace ("&lt;","<").replace ("&gt;",">")
	reg=compile ("\<.+?>")
	text=reg.sub ("<",text)
	reg=compile ("([\<\> ][\>\< ])+")
	text =reg.sub (" ",text)
	reg =compile (" *: *")
	text =reg.sub (":",text)
	if not filter :
		speak ([text], symbolLevel=SYMLVL_SOME)
		return
	from re import escape

	text =text.replace ("mailto:","")
	reg =compile (_(u"(\s+|\-{5} ?(E-mail d'origine|Message d'origine|Original Message) ?\-{5})"))
	text =reg.sub (" ",text)
	reg =compile (u"((((From|De|Expéditeur):.+?(Sujet|Subject|Objet):.+?%s)))" % escape (endSubj))
	l=reg.findall (text)
	for e in  l:
		e= e[0]
		x=e.split (":")[1]
		arobase =x.find ("@")
		if arobase !=-1:x=x[:arobase]
		x=x.replace ("'","").replace ("\"","")
		if x.count (" "):x=x[:x.rfind (" ")]
		text=text.replace (e,_(u"\n. %s a écrit . ") % x)
	#suppression date 
	#pour le confort 
	text =text.replace ("<","")
	#autre champ du style le ... a écrit ...
	s=u">> > C'aurait été con. >> > >> > J.-F. >> > >> >"
	#if text.count (s):text=text[text.find (s)+len (s):]
	reg =compile (_(u"((\s*(Dans un e\-mail daté du|Le) (\d\d[\-/]\d\d[\-/ ]|\d\d .+? )\d{2,4}( (. )?\d\d:\d\d(:\d\d .+?, .+?)?)?,\s*(.+?)a écrit:))"))
	l=reg.findall (text)
	for e in l :
		x=e[7]
		if x.count ("@"):
			x=x.split("@")[0]
			i=x.rfind (" ")
			if i !=-1:x=x[:i]
			text=text.replace (e[0],_(u"\n. %s a écrit. ") % x)
		else:
			text =text.replace (e[0],_(u"\n. %s a écrit.") % x)
	text=text.strip ()
	#modification de lien 
	reg =compile ("https?://.+?\s?.+?\s")
	l=reg.findall (text)
	for e in l : 
		text =text.replace (e,_(u". lien cliquable…. "))
	if reverse :
		text=text.split ("\n")
		text.reverse ()
		text =("\n").join (text)
	#vérifie si le texte est vide 
	reg =compile ("\S")
	if not reg.search (text):text =_(u"pas de texte ")
	speak  ([text], symbolLevel=SYMLVL_SOME)


# getSelectedTab 
# le paramètre o doit avoir le role 34 frame
# retourne :
#objet tab, index, nom si un onglet   sélectionné est trouvé
# ou objet Frame, index négatif, nom Frame si pas d'onglet trouvé
def getSelectedTab(o, first=False):  
	def getR(o2) :
		if not o2 : return -1
		try :
			return o2.role
		except :
			return -1

	if o.role != 34 : 
		while o :
			if o.role == 34 :
				break
			o = o.parent
		if not o or o.role != 34 :	
			return o, -1, "role != frame pour param getSelectedTab"
	oFrame = o
	#z.mtlog.add(u"Début getSelectedTab")
	# cherche :     niveau 3, 0 sur 1, ID=tabmail-tabs, role TABCONTROL=23 Tag: tabs, childCount=7, sans nom, Chemin : role WINDOW=1|, role FRAME=34|, role TOOLBAR=35 tabs-toolbar|, role TABCONTROL=23 tabmail-tabs, WindowClass=MozillaWindowClass ;

	# 1 cherche : role = 35 et id=tabs-toolbar 
	#z.mtlog.addprops(o, "getSelectedTab objet frame   avant recherche tab_toolbar: ")
	for i in range (o.childCount-2, 20, -1) :
		try :
			c = o.getChild(i)
		except :
			#z.mtlog.addprops(o, "Exception sur getChild : " + str(i))
			return oFrame, -2, "except"
		r = getR(c)
		if r < 0 : return o, -4, "except" 
		if r == 35 :
			ID = str(utilTB.getIA2Attribute(c))
			if  ID == "tabs-toolbar" :
				o = c
				break
	if not c : return oFrame, -2, "no tabs-toolbar"
	
	# cherche :    niveau 3, 0 sur 1, ID=tabmail-tabs, role TABCONTROL=23 Tag: tabs, childCount=7, sans nom, Chemin : role WINDOW=1|, role FRAME=34|, role TOOLBAR=35 tabs-toolbar|, role TABCONTROL=23 tabmail-tabs, WindowClass=MozillaWindowClass ;
	#z.mtlog.addprops(o, "Avant recherche role tabControl")
	try :
		c = o.firstChild
	except :
		#z.mtlog.add("Exception sur getFirstChild  pour trouver tabControl")
		return o, -4, "except"
	if not c : return oFrame, -4, "no-tabcontrol"
	# if first : # force main Tab
		# beep(700, 50)
		# o = c.firstChild
		# if  controlTypes.STATE_SELECTED not in o.states : o.doAction()
		# z.mtlog.addprops(o, "Premier onglet ? ")
		# return o, 0, o.name  
	o = c
	# cherche : role=22
	#z.mtlog.addprops(o, "Avant recherche tab dans : ")
	try :
		c = o.firstChild
	except :
		#z.mtlog.addprops(o, "Exception sur getFirsChild de tabControl")
		return o, -5, "except"
	i = 0
	while c :
		#z.mtlog.addprops(c, "tab : ")
		if c.role == 22 and (controlTypes.State.SELECTED if hasattr(controlTypes, "State") else controlTypes.STATE_SELECTED) in c.states :
			break
		i += 1
		c = c.next
	if not c : return 0, -6, "no selected tab"
	#z.mtlog.addprops(c, "tab trouver : ")
	return c, i, str(c.name)

def getTabTypeFromTabObject(idx, nm) :
	if u"Fichiers enregistrés" in nm :
		tabType = "sp:downloads"
	elif 		u"Préférences" in nm :
		tabType = "sp:preferences"
	elif "Gestionnaire de modules complémentaires" in nm :
		tabType = "sp:addons"
	elif u"Paramètres des comptes Courrier et Groupes" in nm :
		tabType = "sp:accounts"
	elif "Configuration du compte" in nm :
		tabType = "sp:newaccount"
	elif "Modules pour Thunderbird" in nm: 
		tabType = "sp:addonsearch"
	else :
		tabType = "default," + str(idx)
		#z.mtlog.add("getTabType sortie : " + tabType)
	return tabType


def getCurTab2(obj, setGlobal, appMod, origin="choose") :
	global   curTab
	oTab, idx, name = getSelectedTab(obj)
	if idx < 0  : # exception dans getSelectedTab, pas encore d'onglet sélectionné
		#z.mtlog.add("getCurTab l 234,  pas de tab, raison : " + name)
		hwFG = winUser.getForegroundWindow()
		title = winUser.getWindowText(hwFG)
		ct =  getTabTypeFromTabObject(0, title) 
	else :
		ct =  getTabTypeFromTabObject(idx, name) 
	if setGlobal : curTab = ct
	return ct
def getCurTabFromPP(oPP, setGlobal=True) : # PP = propertypage
	global   curTab
	if oPP.role != 57 : return "error role is not 57"
	ct = ""
	ID =  str(utilTB.getIA2Attribute(oPP))
	if ID == "mailContent" :
		#z.mtlog.addprops(oPP.firstChild, "firstChild de property page")
		ct =  "default" # on n'a pas encore accès aux tabs à ce stade.
	elif "TabWrapper" in ID: # onglets spéciaux # contentTabWrapper, preferencesTabWrapper
		hwFG = winUser.getForegroundWindow()
		title = winUser.getWindowText(hwFG)
		ct =  getTabTypeFromTabObject(0, title) 
	if ct and  setGlobal :
		curTab = ct
	return ct
	
from keyboardHandler import KeyboardInputGesture
from time import sleep
from tones import beep
def sendKey(keyName, num=1, delay=0.01) :
	for i in range (1, num) :
		KeyboardInputGesture.fromName(keyName).send()
		sleep(delay)
import winUser
def appTitle() :
	hwFG = winUser.getForegroundWindow()
	title = winUser.getWindowText(hwFG)
	title = title.split("illa")[0]
	#z.mtlog.add("appTitle " + title)
	return str(title)
	
def isappReady() :
	hwFG = winUser.getForegroundWindow()
	title = winUser.getWindowText(hwFG)
	#message(u"titre : " + title)
	if "Accueil" not in title and "argement" not in title : 
		#message(u"prêt " + title)
		return True
	return False

def reportBug(o, fileName) :
	z.memlog = z.memoryLog(True, "c:\\windows\\temp") # 1er param :  True=actif ou Falses=inactif
	z.memlog.add(u"Ce problème étant intermittent, merci de m'aider à en trouver la cause en m'envoyant le texte ci-dessous à l'adresse :\nplr.listes@rptools.org\n")
	z.memlog.add(fileName)
	z.memlog.addprops(o, "Objet courant: ")
	z.memlog.add(z.getTextStates(o))
	z.memlog.save(fileName)
	z.memlog = None
	return

def inputBox (label, title, postFunction, startValue=""):
	import gui
	import wx
	d = wx.TextEntryDialog(
		gui.mainFrame,
		label,
		title,
		style = wx.OK | wx.CANCEL)
	d.Value = startValue
	def callback(result):
		if result == wx.ID_OK:
			# On a validé sur OK, d.Value récupère le contenu de la saisie, on peut l'analyser ici.
			if postFunction :
				wx.CallAfter(postFunction, d.Value)
			else : 
				copyToClip(d.Value)
				message(u"Copié")
				sleep(0.4)
		else :
			wx.CallAfter(postFunction, "ibCancel")
	gui.runScriptModalDialog(d, callback)
	#CallAfter(KeyboardInputGesture.fromName ("control+a").send) 

