# -*- coding: utf-8 -*-
# globalPlugins/Thunderbird.py
import globalPluginHandler, addonHandler
import api
import ui
import speech
import wx
from .shared import updateLite
#from keyboardHandler import KeyboardInputGesture
from time import time
import winUser
#import config
from tones import beep
import os, sys
#from gui import messageBox
# _curAddon = addonHandler.getCodeAddon()
# sharedPath = os.path.join(_curAddon.path, "AppModules\\shared")
# sys.path.append(sharedPath)
# import lastTabMgr as ltMgr
# del sys.path[-1]

class GlobalPlugin(globalPluginHandler.GlobalPlugin):
	focusNothing = False
	timer = None
	timerStartedAt = 0
	def __init__(self, *args, **kwargs):
		self.loadCfg()
		super (GlobalPlugin, self).__init__(*args, **kwargs)
		wx.CallAfter(updateLite.checkUpdate, True) # auto
	def loadCfg(self) :
		confPath = api.config.getUserDefaultConfigPath()+ "\\Thunderbird.ini"
		if  not os.path.exists(confPath) :  return  #self.focusNothhing = False
		from configobj import ConfigObj
		options =ConfigObj (confPath)
		try :
			tmpStr  = options['startup']['focusNothing']
			self.focusNothing = (True if tmpStr == "True" else False)
		except :
			pass
		#print("self.focusNothing : " + str(type(self.focusNothing)))
		return
	
	# plus utilisée : détection fenêtre TB trop tardive ou absente par rapport à chooseOverlay dans appModule
	# def event_foreground(self, obj, nextHandler) :
	
	def notifyAppmodule(self):
		obj=api.getForegroundObject()
		appMod =  obj.appModule
		if appMod and hasattr(appMod, "setStarted") :
			appMod.setStarted() 
			return True
		return  False
	def trackTitle(self) :
		hwFG = winUser.getForegroundWindow()
		title = winUser.getWindowText(hwFG)
		if "- Mozilla Thunderb" in title:
			if self.notifyAppmodule() :
				self.timer = None
				return
		if time() - self.timerStartedAt < 30.0 : # secondes
			self.timer.Start()
		else :
			self.timer = None
		return
	def script_startTB(self, gesture) :
		hwFG = winUser.getForegroundWindow()
		title = winUser.getWindowText(hwFG)
		if "- Mozilla Thunderb" in title:
			ui.message(u"Thunderbird est déjà en cours d'exécution")
			return
		#wx.CallLater(50, speech.speakMessage , "Hello everyone !", priority = speech.priorities.Spri.NOW)		
		focusTaskButton()
		ui.message(u"Démarrage  de Thunderbird.")
		tbPaths = ("C:\\Program Files\\Mozilla Thunderbird\\thunderbird.exe", "C:\\Program Files (x86)\\Mozilla Thunderbird\\thunderbird.exe")
		idx = -1
		if  os.path.exists(tbPaths[0]) :
			idx = 0 
		elif   os.path.exists(tbPaths[1]) :
			idx = 1
		else :
			#messageBox(_(u"Thunderbird.exe non trouvé dans C:\Program files"), _("Lanceur de Thunderbird"), wx.CLOSE|wx.ICON_WARNING)
			ui.message(u"Thunderbird.exe non trouvé dans C:\\Program files")
			return
		startProgramMaximized(tbPaths[idx])
		if self.focusNothing : return
		self.timerStartedAt = time()
		self.timer = wx.CallLater(200, self.trackTitle)
		return
	script_startTB.__doc__ = u"Lance Thunderbird"
	script_startTB.category=u"Thunderbird, lanceur et mise àjour"

	def  script_searchUpdate(self, gesture) :
		wx.CallAfter(updateLite.checkUpdate, False)
	script_searchUpdate.__doc__ = u"Recherche une mise à jour de Thunderbird+"
	script_searchUpdate.category=u"Thunderbird, lanceur et mise àjour"
	
	__gestures={
		u"kb:control+alt+²": "startTB",
		u"kb:control+alt+shift+²": "searchUpdate",
		# #"kb:control+backspace": "sendControlF4",
		# "kb:control+break": "sendControlW",
		# "kb:alt+pause": "closeAllWindows",
	}

def startProgramMaximized(exePath):
	import subprocess
	SW_MAXIMIZE = 3
	info = subprocess.STARTUPINFO()
	info.dwFlags = subprocess.STARTF_USESHOWWINDOW
	info.wShowWindow = SW_MAXIMIZE
	subprocess.Popen(exePath, startupinfo=info)
import ctypes
from oleacc import AccessibleObjectFromWindow
def focusTaskButton():
	""" set focus on  weather button or startbutton """
	hTask = ctypes.windll.user32.FindWindowExA(None, None, b"Shell_TrayWnd", None)
	if not hTask : return False
	print("winver : " + str(sys.getwindowsversion()))
	if sys.getwindowsversion().major < 10 :
		cn = (b"start", b"DynamicContent1")
	else :
		cn = (b"DynamicContent1", b"start")
	for c in cn :
		hButton = ctypes.windll.user32.FindWindowExA(hTask, 0, c, 0)
		if hButton : break
	if not hButton : return False
	oAttribs = AccessibleObjectFromWindow(hButton, winUser.OBJID_WINDOW) # winUser.OBJID_WINDOW ou   winUser.OBJID_CLIENT) = -4
	
	#max = oAttribs.accChildCount
	#ui.message("oAttribs.accChildCount : " + str(oAttribs.accChildCount))
	#for i in range(0, max - 1)
	# if (oAttribs.accState(i) & STATE_SYSTEM_INVISIBLE):
		# continue
	#role = oAttribs.accRole[0]
	#ui.message("role : " + str(role))
	# ne fonctionne pasoAttribs.accName[0] = "test"
	#ui.message("nom=" + oAttribs.accName[0])
	#oAttribs.accDoDefaultAction(0) # opens start menu
	oAttribs.accSelect(1) # set focus
	return True

# new speechMode functions by Paulber19 for NVDA 2021.1+ ander previous 
def getSpeechMode():
	try:
		# for nvda version >= 2021.1
		return speech.getState().speechMode
	except AttributeError:
		return speech.speechMode

def setSpeechMode(mode):
	try:
		# for nvda version >= 2021.1
		speech.setSpeechMode(mode)
	except AttributeError:
		speech.speechMode = mode


def setSpeechMode_off():
	#print(u"Fonction setSpeechMode_off")
	try:
		# for nvda version >= 2021.1
		speech.setSpeechMode(speech.SpeechMode.off)
	except AttributeError:
		speech.speechMode = speech.speechMode_off
